<template>
  <div>
    <div class="dashboard__header">
      <h1 class="dashboard__title">ویرایش محصول</h1>
      <div class="dashboard__actions">
        <Button type="text" color='dark' light round size="sm" @click.native="$router.push('/dashboard/admin/products')">
          <template #icon>
            <BackIcon />
          </template>
        </Button>
      </div>
    </div>
    <div class="dashboard__body">
      <DashboardNavigation class="dashboard__nav" active="products" />
      <Card title="اطلاعات محصول" class="dashboard__content">
        <ProductForm :categories="categories" @create="onCreate" :product="product" />
      </Card>
    </div>
  </div>
</template>

<script>
import DashboardNavigation from "@/components/layout/DashboardNavigation";
import BackIcon from "@/assets/svgs/back.svg";
import Button from "@/components/base/Button";
import Card from "@/components/base/Card";
import ProductForm from "@/components/dashboard/ProductForm";

export default {
  components: {
    DashboardNavigation,
    BackIcon,
    ProductForm,
    Button,
    Card
  },
  head() {
    return {
      title: "ویرایش محصول"
    }
  },
  layout: "dashboard",
  async asyncData(context) {
    let categories = [];
    let product = {};
    await context.store.dispatch('shop/fetchCategories').then(response => {
      if (response.status === 200) {
        categories = response.data.data;
      }
    }).catch(error => {
      console.log(error);
    });
    await context.store.dispatch('shop/fetchProduct', context.route.params.id).then(response => {
      if (response.status === 200) {
        product = response.data.data;
      }
    }).catch(error => {
      console.log(error);
    });
    return {
      categories,
      product
    }
  },
  methods: {
    onCreate() {
      this.$router.push('/dashboard/admin/products');
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.dashboard__content
  align-self flex-start
</style>